Subject: Re: Why is pushing to stash not allowed without an initial commit?

From: Sergey Organov <[email-masked]>
Date: Thu, 17 Oct 2024 23:50:49 +0300

Taylor Blau <[email-masked]> writes:

> On Thu, Oct 17, 2024 at 08:51:29PM +0530, Abhijeet Sonar wrote:
>> I see that the stash commit has two parents: the initial commit and the
>> commit that actually holds the files that were stashed.
>>
>> If git were to allow a stash entry with no initial commit, it would have to
>> create a stash commit with only one parent (i.e. the commit labeled with
>> 'index on <branch>'). I wonder if there is a reason this would be bad and
>> therefore not allowed?
>
> Right, each stash entry has two parents:
>
>   - The first parent is the state of HEAD in your repository when you
>     created the stash entry,
>
>   - The second parent is the state of the index at the same point
>
> So there would be no reasonable value to substitute in for the first
> parent in the case where your repository does not yet have any
> commits.

I still wonder why Git has no concept of the ultimate null-commit from
which all the Git world descends? Looks like it'd help to have one to
handle such corner cases gracefully. Was it just an oversight of
original design that isn't worth fixing already?

-- 
Sergey